/*---------------------------------------------------------------------------*/
/* class2z.c                                                                 */
/*---------------------------------------------------------------------------*/

#include "class2z.h"


void class2z( class, id, dmat, z, zid, k, n, nrz, p, q, nclust, flag)

     double *class, *id, *dmat, *z, *zid;
     int    *k, *n, *nrz, *p, *q, *nclust, *flag;

{
  MATRIX *C[MAX_NUM_CLUSTS], *ID[MAX_NUM_CLUSTS], *cin, *idin;
  MATRIX *D[MAX_NUM_CLASS][MAX_NUM_CLASS], *din, *Z, *Zid, *ID_num;
  int    i, j, a, b, one, count, ni, cc, rr;

  one=1;
  from_S( class, n, &one, cin);
  from_S( id, n, &one, idin);
  from_S( dmat, p, q, din);
  from_S( z, nrz, q, Z);
  from_S( zid, nrz, &one, Zid);

  if( *k > MAX_NUM_CLASS ){ printf("k = %i, MAX_NUM_CLASS = %i.\n",
				   *k,MAX_NUM_CLASS);
			    printf("change class2z.h and recompile.\n");
			    exit(1); }

  if( *nclust > MAX_NUM_CLUSTS ){ printf("nclust = %i, MAX_NUM_CLUSTS = %i.\n",
					 *nclust,MAX_NUM_CLUSTS);
				  printf("change class2z.h and recompile.\n");
				  exit(1); }

printf("[1]\n");

  count=0;
  for(i=0;i< *k;i++){
    for(j=i;j< *k;j++){
      D[i][j]=create_matrix(1,*q,EPHEMERAL);
      for(rr=0;rr<*q;rr++) MEL(D[i][j],0,rr)=MEL(din,count,rr);
      count++;
    }
  }
  destroy_matrix(din);

printf("[2]\n");

  split(cin,idin,C);
  split(idin,idin,ID);
  destroy_matrix(idin);
  destroy_matrix(cin);

  ID_num=create_matrix(*nclust,one,EPHEMERAL);
  for(i=0;i<*nclust;i++){
    MEL(ID_num,i,0)=MEL(ID[i],0,0);
    destroy_matrix(ID[i]);
  }

printf("[3]\n");

  count=0;
  for(cc=0;cc<*nclust;cc++){
    ni=C[cc]->nrows;
    if(ni==1){
      for(rr=0;rr<*q;rr++) MEL(Z,count,rr)=0.0;
      MEL(Zid,count,0)=MEL(ID_num,cc,0);
      count++; 
    }else{
      for(i=0;i<(ni-1);i++){
	for(j=(i+1);j<ni;j++){
	  a=IMIN(MEL(C[cc],i,0),MEL(C[cc],j,0));
	  b=IMAX(MEL(C[cc],i,0),MEL(C[cc],j,0));
	  for(rr=0;rr<*q;rr++) MEL(Z,count,rr)=MEL(D[a-1][b-1],0,rr);
	  MEL(Zid,count,0)=MEL(ID_num,cc,0);
	  count++;
	}
      }
    }

  }

printf("[4]\n");

  if( count != Z->nrows ) *flag=1;

    to_S( Z, z);
    to_S( Zid, zid);

    for(i=0;i<*nclust;i++) destroy_matrix(C[i]);
    destroy_matrix(ID_num);

  for(i=0;i< *k;i++){
    for(j=i;j< *k;j++){
      destroy_matrix(D[i][j]);
    }
  }

}
/*---------------------------------------------------------------------------*/


