/*---------------------------------------------------------------------------*/
/* mat_uniq.c                                                                */
/*---------------------------------------------------------------------------*/

#include "chanmatstruct.h"
#include "chanmatfuns.h"



extern int compare_matrices();

void mat_uniq( x, id, nrx, p, n_clust, n_unique, nrxout, xlabel )

     double *x, *id, *xlabel;
     int    *nrx, *p, *n_clust, *n_unique, *nrxout;

{
  MATRIX **X, **ID, *xin, *idin, *temp;
  int    nclust, i, j, totalout, one, count, located;

  one=1;
  from_S( x, nrx, p, xin );
  from_S( id, nrx, &one, idin );
  make_permanent( xin );
  make_permanent( idin );

  nclust = *n_clust;

  X = (MATRIX **)malloc( (unsigned)( nclust * sizeof(MATRIX *) ) );
  ID = (MATRIX **)malloc( (unsigned)( nclust * sizeof(MATRIX *) ) );

printf("[0]\n");


  split( xin, idin, X );

  split( idin, idin, ID );


  for(i=0;i<nclust;i++){
    make_permanent( X[i] );
    make_permanent( ID[i] ); }

printf("[1]\n");

  count = 1;
  *xlabel = 1.0;
  totalout=(X[0]->nrows);


  for(i=1;i< nclust;i++){
    j=0;
    located=0;

    do{
      located = compare_matrices( X[j], X[i] );
      j++;
    }while( !located && (j<count) );
    j--;
    if( located ){
      *(xlabel+i) = j+1; /* 1-based index labels */
    }else{
      count++;
      plug( X[i], xin, totalout, 0 );
      plug( ID[i], idin, totalout, 0 );
      totalout += X[i]->nrows;
      temp=X[count-1];
      X[count-1]=X[i];
      X[i]=temp;
      *(xlabel+i) = (double) count;
    }
  }

printf("[2]\n");

    to_S( xin, x );
    to_S( idin, id );


  *nrxout = totalout;
  *n_unique = count;

    for(i=0;i<nclust;i++){
      destroy_matrix(X[i]);
      destroy_matrix(ID[i]);
    }

  cfree(X);
  cfree(ID); 

}
/*---------------------------------------------------------------------------*/

int compare_matrices( x1, x2 )

MATRIX *x1, *x2;

{
int i, n, out;
double *x1head, *x2head;

out=0;

x1head = x1->data;
x2head = x2->data;

if( (x1->nrows)==(x2->nrows) ){
  n = (x1->nrows)*(x1->ncols);
  i=0;
  do{
    out = *(x1head+i) == *(x2head+i);
    i++;
  }while( out && i<n );
}

return out;

}
/*---------------------------------------------------------------------------*/


