mat.uniq<-function( x, id ){
#
# function to return the unique X_i matrices
#
# ARGUMENTS:	x = stacked design matrices (x_i i=1:nclust)
#		id = cluster identifier
#
# RETURN:	xout = stacked unique design matrices (xout_i 1=1:n.unique)
#		xoutid = cluster identifier for xout
#		xlabel = label of which unique xout_j corresponds to x_i
#		n.clust = number of clusters
#		n.unique = number of unique x_i matrices
#
if( is.null(nrow(x)) ) x_matrix(x,ncol=1)
if( nrow(x) != len(id) ){
	cat("X and ID do not conform!\n")
	stop( 0 ) }
nclust_len(table(id))
p_ncol(x)
nrx_nrow(x)
xlabel_as.double(rep(0,nclust))
n.unique_0
nrxout_0
x.names_NULL
if( !is.null(dimnames(x)) ) x.names_dimnames(x)[[2]]
x_as.double(x)
id_as.double(id)
n.unique_as.integer(n.unique)
nrxout_as.integer(nrxout)
#
out<-.C("mat_uniq",
	x,
	id,
	nrx,
	p,
	nclust,
	n.unique,
	nrxout,
	xlabel )
#
rr_out[[7]]
xout_matrix(out[[1]],ncol=p)
if( !is.null(x.names) ) dimnames(xout)_list(NULL,x.names)
#
z_list( xout=xout[1:rr,], xoutid=out[[2]][1:rr], xlabel=out[[8]], 
	n.clust=nclust, n.unique=out[[6]] )
z
}

