ord.EE _ function( x, y, id, z , zid=NULL, z.balance=F,
		ncuts=1, binit, ainit, bweight = "full", aweight = "diagonal",
		method="gee1", EE1.invar=T, tol=0.001, 
		lambda1=NULL, lambda2=NULL )
{
cat("=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-\n")
cat("  dependent data logistic regression S interface 1.3 94/09/06   \n")
cat("         regression analysis for dependent ordinal data         \n")
cat("=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-\n")
	len <- length
	nrowx <- nrow(x)
	p <- len(binit)
	q <- len(ainit)
	nzrows <- nrow(matrix(z,ncol=q))
	if( len(y) != nrowx ){
		cat("y and x don't conform!\n")
		stop( 0 ) }
	if( len(id) != nrowx ){
		cat("id and x don't conform!\n")
		stop( 0 ) }
	if( q>1 ){
		if( ncol(z) !=q ){
		  cat(paste("ord.EE:  ncol(z) =",ncol(z),"length(ainit) =",
			q,"\n"))
		  cat("          these do not conform!") 
		  stop( 0 ) }
	}else{
		if( !is.matrix(z) ){
		  z_matrix(z,ncol=1)
		}else{
		  if( ncol(z) != q ){
		    cat(paste("ord.EE:  ncol(z) =",ncol(z),"length(ainit) =",
			q,"\n"))
		    cat("          these do not conform!") 
		    stop( 0 ) }
		}
	}
	if(ncol(x)!=p)
		stop("x mat must have p columns p=dim(binit)")
	xnames _ dimnames(x)[[2]]
	if (is.null(xnames)) xnames _ paste("x",1:p,sep="")
	clnames_NULL
	if( is.matrix(z) ) clnames_dimnames(z)[[2]]
	if( is.null(clnames) ) clnames _ paste("a",1:q,sep="")
#
	if( is.null(lambda1) ){
		lambda1<-matrix( 0, p, p)
	}else{
		if( nrow(lambda1)!=p || ncol(lambda1)!=p ){
		  cat("ord.EE:  lambda1 must be p x p matrix. \n")
		  stop( 0 )
		}
	}
	if( is.null(lambda2) ){
		lambda2<-matrix( 0, q, q)
	}else{
		if( nrow(lambda2)!=q || ncol(lambda2)!=q ){
		  cat("ord.EE:  lambda2 must be q x q matrix. \n")
		  stop( 0 )
		}
	}
#
	if( z.balance ){
 	  if( length(table(table(id))) != 1 ){
	    cat("ord.EE: z.balance=T requires all clusters to be same size\n")
	    stop( 0 )
	  }else{
	    ni_as.integer(names(table(table(id))))/ncuts
	    nc2_(ni*(ni-1)/2)*(ncuts^2)
	    if( nrow(matrix(z,ncol=q)) != nc2 ){
	       cat(paste("ord.EE: z.balance =T; common cluster size =",
		ni,"\n"))
	       cat(paste("        nrow( z ) =",nrow(z),", should be ",
		nc2,"\n" ))
	       stop( 0 )  }
	    zid_rep(1,nc2)
		}
	}else{
	    if( is.null(zid) ){
		cat("ord.EE:  zid is required argument when z.balance=F\n")
		stop( 0 )
		}
	}
	cov <- matrix(0, p + q, p + q)
	modcovbeta <- matrix(0,p,p)
	# pick weighting for beta
	b.indep <- 0
	if(bweight == "independence") b.indep <- 1 else if(bweight!="full")
		stop(paste("ord.EE:  unknown bweight option:", bweight))
	a.weight <- 0
	if(aweight == "block") a.weight <- 1 else if(aweight!="diagonal")
		stop(paste("ord.EE:  unknown aweight option:", aweight))
	method.int_match(method,c("alr","gee1"))
	if(method.int<1)
		stop(paste("ord.EE:  unknown method:",method))
	maxiter<-25
	int.parms_rep(0,11)
	int.parms[1]_as.double(nrowx)
	int.parms[2]_as.double(nzrows)
	int.parms[3]_as.double(p)
	int.parms[4]_as.double(q)
	int.parms[5]_as.double(ncuts)
	int.parms[6]_as.double(maxiter)
	int.parms[7]_as.double(b.indep)
	int.parms[8]_as.double(a.weight)
	int.parms[9]_as.double(method.int)
	int.parms[10]_as.double(EE1.invar)
	int.parms[11]_as.double(z.balance)
	niter_0
	ctol_0.0
	z <- .C("ord_EE",
		as.double(x),
		as.double(y),
		as.double(z),
		as.double(id),
		as.double(zid),
		beta = as.double(binit),
		alpha = as.double(ainit),
		cov = as.double(cov),
		modcovbeta = as.double(modcovbeta),
		as.double(tol),
		as.double(int.parms),
		as.double(lambda1),
		as.double(lambda2),
		niter=as.integer(niter),
		ctol=as.double(ctol) )

#
	if( method.int==1 ){ 
		method_"ALR"
		aweight_"diagonal (only option with ALR)"
	}else{
		if( !EE1.invar ){
			method_"GEE1 - Lipsitz,Laird,Harrington"
		}else{
			method_"GEE1 - invariant"
		}
	}
#	
	ans <- list(z[["beta"]], z[["alpha"]], matrix(z[["cov"]], p + q, p +
		q), matrix(z[["modcovbeta"]],p,p), method, bweight, aweight,
		lambda1=lambda1, lambda2=lambda2, niter=z[["niter"]], 
		ctol=z[["ctol"]] )
	names(ans) <- c("beta", "alpha", "robcov", "modcovbeta","method",
		"b.weight","a.weight","lambda1","lambda2","niter","ctol")
	names(ans[["beta"]]) _ xnames
	names(ans[["alpha"]]) _ clnames
	ans
}





