ord.EE.setup.v2_function( x, y, id, cuts, z, zid, w.model="common" ){
#
# PURPOSE:	create input for ord.EE().  This function is particularly
#		useful when a basic z matrix has been created by z.class
#		or z.dsp.
#
# INPUT:  	x = design matrix (without intercept)
#		y = ordinal measurements
#		id = cluster identifier
#		cuts = category lower boundaries for y
#		z = association design matrix (with intercept)
#		zid = association model cluster identifier
#		w.model = "common" global OR's or "full" global OR's
#		
# RETURN:	returns list with structures needed by ord.EE()
#
	ncuts<-length(cuts)
	nobs_length(y)
	if( !(w.model=="common" || w.model=="full") ){
		print(paste("w.model =",w.model))
		print("choices are either common or full")
		stop( 0 ) }
	y.ord<-ord.build.y( y, cuts )
	id.ord<-ord.build.id( id, ncuts)
	x.ord<-ord.build.x( x, ncuts )
	if(w.model=="common"){
		zmat_matrix(1,nrow=ncuts^2,ncol=1) }else{
		zmat_cbind(1,diag(rep(1,ncuts^2))[,-1]) }
	zid.ord_as.vector(kronecker(matrix(zid,ncol=1),zmat))
	z.ord_kronecker(z,zmat)
	ret_list(x=x.ord,y=y.ord,id=id.ord,z=z.ord,zid=zid.ord,ncuts=ncuts,
		w.model=w.model)
	ret
}




