#define ALPHA_WRITE 0
#define oMatdump( x ) /* matdump( x ) */
#define oPrint( x ) /* printf("     o:  ");printf( x ) */

#define cfree free

/* ord_EE.c @(#) ord_EE.c 1.0 94/09/06 */
/* ordinal data */
/* alternating logistic regression and GEE1 */

#include "ord_EE.h"

#define sweep luinv 

#define gPrint(x)  /* printf("     g:  ");printf(x) */
#define gMatdump(x) /* matdump(x) */

static double dmaxarg1, dmaxarg2;
#define IMAX(a,b) (dmaxarg1=(a), dmaxarg2=(b), (dmaxarg1) > (dmaxarg2) ? \
(int)(dmaxarg1) : (int)(dmaxarg2))

static double dminarg1, dminarg2;
#define IMIN(a,b) (dminarg1=(a), dminarg2=(b), (dminarg1) < (dminarg2) ? \
(int)(dminarg1) : (int)(dminarg2))


MATRIX *stack(), *matantilogit(), *ord_star(), *matxdiagasvec(), *oneminus(); 
MATRIX *ord_flip(), *ord_flipz(), *luinv(), *ord_star_EE1();
MATRIX *make_rvar(), *make_irvar(), *matsort(), *blockdiag_x_mat();

MATRIX **get_alpha_blocks();

double matmaxabs();

extern int choose2();

int ord_rfun();


typedef struct matrix_pair_p   /* appended! */
	{
	MATRIX *X1;
	MATRIX *X2;
	MATRIX **SB;
	} MATRIX_PAIR_P;

typedef struct matrix_triplet_p
	{
	MATRIX *X1;
	MATRIX *X2;
	MATRIX *X3;
	MATRIX **SA;
	} MATRIX_TRIPLET_P;

typedef struct matwcond
	{
	MATRIX *mat;
	double condition;
	} MATWCOND;

MATWCOND *invwcond();


MATRIX_PAIR_P *get_beta_comps(), *beta_comps;
MATRIX_TRIPLET_P *get_alpha_ALR(), *alpha_comps, *falpha_comps;
MATRIX_TRIPLET_P *get_alpha_EE1();
		

void ord_EE( x, y, z, id, zid, initbeta, initalpha, cov, modcovbeta, 
             tol, int_parms, lambda_1, lambda_2, niter, ctol )

double *x, *y, *id, *initbeta, *initalpha, *cov, *modcovbeta;
double *tol, *z, *zid, *int_parms, *lambda_1, *lambda_2, *ctol;
integer *niter;


#define Matdump( x ) 
#define Printf( x )
#define IPrintf( x )
#define sMatdump( x ) { printf(" x \n"); matdump( x ); }
#define sPrintf( x ) { printf(" x -> %lf\n", x ); }
#define sIPrintf( x ) { printf(" x -> %d\n", x ); }
{

MATRIX *xin, *yin, *idin, *zin, *beta, *alpha, *zidin, *zlin, *cl2in;
MATRIX **X, **Y, **Z, **ZL, **CL2;
MATRIX *thisZ, *temp1, *temp2;
MATRIX *mu1, *psi2, *C, *B, *op, *del1, *del2, *nbeta;
MATRIX *varmat, *S, *del1s, *del2s, *adel1s, *adel2s, *delta;
MATRIX *D, *G, *E, *ystar, *Zeta;
MATRIX *aop, *aH1, *saH2, *alvarmat, *DtEG, *aldel, *nalpha, *fulldel;
MATRIX *robvmat, *XZchange, *parms, *lambda1, *lambda2;
int one, eleven, nclust, c=0, iter, ni, nc2, i=0, j=0;
int r0, k, l, flip, cuts, invariant, EE1_invariant, alpha_block;
double mu2, off, mui, muj, psi2ij, a, chkrt;
double gamr, mpr, tmpm, mu2ij, tmpd, toff, tmpalogit, tmpn1;
double dNdal, tmpN1, dDdalk, dndalk, xil, xjl, dmidbl, dmjdbl;
double tmpf2, tmpf2d, Zij, Zrk, Alphak, dadalk, Dn, chk, zdiff, xdiff;
double dadbl, dnrdbl, tmpf, td;
int  nrowx, nrowz, p, q, ncuts, maxiter, bindep, aweight, method;
int  invar, z_balance, count, rep;
FILE *wfile;

printf("\nord_EE.c:  Estimating Equations Subroutine v1.1 94/10/25 \n\n");

one  = 1;
eleven = 11;

from_S( int_parms, &eleven, &one, parms );
nrowx = (int) MEL(parms,0,0);
nrowz = (int) MEL(parms,1,0);
p = (int) MEL(parms,2,0);
q = (int) MEL(parms,3,0);
ncuts = (int) MEL(parms,4,0);
maxiter = (int) MEL(parms,5,0);
bindep = (int) MEL(parms,6,0);
aweight = (int) MEL(parms,7,0);
method = (int) MEL(parms,8,0);
invar = (int) MEL(parms,9,0);
z_balance = (int) MEL(parms,10,0);
destroy_matrix( parms );

from_S( lambda_1, &p, &p, lambda1 );
make_permanent( lambda1 );
from_S( lambda_2, &q, &q, lambda2 );
make_permanent( lambda2 );

from_S( y, &nrowx, &one, yin )
from_S( id, &nrowx, &one, idin )
from_S( x, &nrowx, &p, xin )
from_S( initbeta, &p, &one, beta )
from_S( initalpha, &q, &one, alpha )

make_permanent( beta );
make_permanent( alpha );

nclust = nchanges( idin );

cuts = ncuts;
EE1_invariant = invar;
alpha_block = aweight;

set_matrix_array( X, nclust );
set_matrix_array( Y, nclust );

split( xin, idin, X );
split( yin, idin, Y );

destroy_matrix( xin );
destroy_matrix( yin );

from_S( z, &nrowz, &q, zin )
make_permanent( zin );
from_S( zid, &nrowz, &one, zidin );
make_permanent( zidin );

set_matrix_array( Z, nclust );


if( z_balance ){
  Z[0]=matcopy( zin );
  make_permanent( Z[0] );
  for(i=1;i<nclust;i++) Z[i]=Z[0];
}else{
  split( zin, zidin, Z );
}


destroy_matrix( zin );
destroy_matrix( zidin );
destroy_matrix( idin );


XZchange = create_matrix( nclust, 1, EPHEMERAL );
for(i=0;i<nclust;i++){
  MEL(XZchange,i,0)=1.0;
  make_permanent( X[i] );
  make_permanent( Y[i] );
  make_permanent( Z[i] );
}


count=nclust;
for( i=1; i<nclust; i++ ){
  if( X[i]->nrows == X[i-1]->nrows ){
    xdiff = matmax( matabs( matsub( X[i], X[i-1] ) ) );
    if( z_balance ){
      if( xdiff == 0.0 ){
	MEL(XZchange,i,0)=0.0;
	count--;
      }
    }else{
      zdiff = matmax( matabs( matsub( Z[i], Z[i-1] ) ) );
      if( (xdiff==0.0) && (zdiff==0.0) ){
	MEL(XZchange,i,0)=0.0;
	count--;
      }
    }
  }/* rows check */
}/* i loop */

printf( "     # changes in (X,Z) as ordered = %i \n", count );
printf( "     # clusters = %i \n", nclust );

iter = 0;
do {
	if ( iter > 0 )
		{
		for ( i = 0 ; i < nclust ; i++ )
			{
			destroy_matrix( beta_comps->SB[i] );
			destroy_matrix( alpha_comps->SA[i] );
			}
		cfree( beta_comps->SB );
		cfree( alpha_comps->SA ); 
		destroy_matrix( beta_comps->X1 );
		destroy_matrix( beta_comps->X2 );
		destroy_matrix( alpha_comps->X1 );
		destroy_matrix( alpha_comps->X2 );
		destroy_matrix( alpha_comps->X3 );

		cfree( beta_comps );
		cfree( alpha_comps ); 

		}
	printf("Starting beta\n");

/* get_beta_comps() checks clean 94/11/08 */

	beta_comps = get_beta_comps( nclust, X, Y, Z, beta, 
				    alpha, bindep, cuts, XZchange );

	printf("Done beta\n");


	make_permanent( beta_comps->X1 );
	make_permanent( beta_comps->X2 );

	temp1 = matsub( beta_comps->X2, matmult( lambda1, beta ) );
	temp2 = matadd( lambda1, beta_comps->X1 );
	delta = matmult( sweep(temp2), temp1 );
  	make_permanent(delta);

	for(k=0;k<p;k++) MEL(beta,k,0) += MEL(delta,k,0);

oMatdump(beta);

	/* CONDIT LOGIST */
	printf("Starting alpha\n");


	if( method == 1){
	  flip = 0;
/* get_alpha_ALR checks clean 94/11/10 */
	  alpha_comps = get_alpha_ALR( nclust, X, Y, Z, beta,
				      alpha, flip, cuts, XZchange );
	}else{
/* get_alpha_EE1 checks clean 94/11/08 */
	  alpha_comps = get_alpha_EE1( nclust, X, Y, Z, beta,
				      alpha, cuts, EE1_invariant,
				      alpha_block, XZchange );
	}

oPrint( "Done alpha.\n");

/* wfile=fopen("EEout","a");
fmatdump( wfile, alpha_comps->X1 );
fmatdump( wfile, alpha_comps->X2 );
fmatdump( wfile, alpha_comps->X3 );
fclose( wfile ); */

	make_permanent( alpha_comps->X1 );
	make_permanent( alpha_comps->X2 );
	make_permanent( alpha_comps->X3 );

	temp1 = matadd( alpha_comps->X1, lambda2 );
	temp2 = matmult( lambda2, alpha );
	temp2 = matsub( alpha_comps->X2, temp2 );
	aldel = matmult( luinv( temp1 ), temp2 );
	make_permanent(aldel);

	for(k=0;k<q;k++) MEL(alpha,k,0) += MEL(aldel,k,0);

if( ALPHA_WRITE ){
  wfile=fopen("EEout","a");
  fprintf(wfile,"\n alpha \n");
  fmatdump(wfile,alpha); 
  fclose(wfile); }

oMatdump( alpha );

oMatdump(transp(delta));
oMatdump(transp(aldel));
	fulldel = stack( delta, aldel );
oPrint("[1]\n");
	destroy_matrix(delta);
	destroy_matrix(aldel);
oPrint("[2]\n");

	chk = matmaxabs( fulldel );

	destroy_matrix( fulldel ); /* matmaxabs() doesn't clean */

	printf("%d, %lf -- iter, curdel\n", iter, chk );

	} while ( iter++ < maxiter && ( chk > *tol ) );


        *niter = iter;
        *ctol = chk;


/* do correction for posterior mode estimation */

        make_ephemeral( beta_comps->X1 );
        beta_comps->X1 = matadd( beta_comps->X1, lambda1 );
        make_permanent( beta_comps->X1 );

        make_ephemeral( alpha_comps->X1 );
        alpha_comps->X1 = matadd( alpha_comps->X1, lambda2 ); 
        make_permanent( alpha_comps->X1 );


	/* compat chk */

        invariant = ( (method==2) );  

	if ( invariant )
		robvmat = make_rvar( nclust, beta_comps, alpha_comps ); 
	else {
		flip = 1; /* change back to 1 */


		falpha_comps = get_alpha_ALR( nclust, X, Y, Z, beta,
					  alpha, flip, cuts, XZchange );

        falpha_comps->X1 = matadd( falpha_comps->X1, lambda2 ); 


		/* robvmat = make_rvar( nclust, beta_comps, falpha_comps ); */
	robvmat = make_irvar( nclust, beta_comps, alpha_comps, falpha_comps ); 
		}

	/* matdump(robvmat); */

	for ( i = 0 ; i < nclust ; i++ )
		{
		destroy_matrix( X[i] );
		destroy_matrix( Y[i] );
		}
        if( ! z_balance ){
	  for(i=0;i<nclust;i++) destroy_matrix( Z[i] );
	}else{
	  destroy_matrix( Z[0] );
	}

	cfree( X );
	cfree( Y );
	cfree( Z );

        destroy_matrix( lambda1 );
        destroy_matrix( lambda2 );

        varmat = sweep( beta_comps->X1 );
        to_S( varmat, modcovbeta )
       
	to_S( robvmat, cov )
	to_S( beta, initbeta )
	to_S( alpha, initalpha )

}

MATRIX_PAIR_P *get_beta_comps( nclust, X, Y, Z, beta, 
				    alpha, bindep, cuts, change )
int nclust, bindep, cuts;
MATRIX **X, **Y, **Z, *beta, *alpha, *change;
{
int c, ni, nc2, i,j, r0, p, condcount, I, J, c1, c2, kill;
MATRIX  *mu1, *psi2, *B, *C, *op, *del1, *del2, *varmat, 
    *del1s, *del2s, *S, *plugmat;
double psi2ij, mui, muj, a, chkrt, mu2;
MATRIX_PAIR_P *ans;
MATWCOND *Binvc;
double mincond = 1.;

p = X[0]->ncols;

ans = (MATRIX_PAIR_P *)calloc( 1, (unsigned)sizeof(struct matrix_pair_p));
ans->SB = ( MATRIX **)calloc(nclust,(unsigned)sizeof(struct matrix));
if ( ans->SB == (MATRIX **)NULL)
	{
	fprintf(stderr,"MATRIX_PAIR_P out of space for SB\n");
	exit(1);
	}

condcount = 0;

del1s = create_matrix( p, p, EPHEMERAL );
del2s = create_matrix( p, 1, EPHEMERAL );

for ( c = 0 ; c < nclust ; c++ ){


   if( MEL(change,c,0)==1.0 ){

	ni = X[c]->nrows;
	ni = ni/cuts;
	nc2 = choose2( ni );

	mu1 = matantilogit( matmult( X[c], beta ) );
	psi2 = matexp( matmult( Z[c], alpha ) );

	make_permanent(mu1);
	make_permanent(psi2);

	if (!bindep)
	{

	B = create_matrix( ni * cuts, ni * cuts, PERMANENT );

	for ( I = 0 ; I < (ni-1) ; I++ )
		{
		for ( J = (I+1) ; J < ni ; J++ )
			{
			  for( c1 = 0 ; c1 < cuts ; c1++ ){
			    for( c2 = 0 ; c2 < cuts ; c2++ ){

			      i = I * cuts + c1;
			      j = J * cuts + c2;

			      r0 = ord_rfun( ni, cuts, I, J, c1, c2 ); 

			psi2ij = MEL( psi2, r0, 0 );
			mui = MEL( mu1, i, 0 );
			muj = MEL( mu1, j, 0 );

			a = 1. + (mui+muj)*(psi2ij-1.);

			chkrt = a*a - 4.*psi2ij*(psi2ij-1.)*mui*muj;

			if (chkrt < 0.) 
			  fprintf(stderr,"Mu2 calcs have invalid sqrt.\n");

		/*	if (abs(psi2ij-1.) < SMALL )
			  fprintf(stderr,"Mu2 calcs have invalid denom.\n"); */

			if ( fabs(psi2ij-1.) < SMALL ) mu2 = mui*muj;
			else mu2 =
			  ( a - sqrt( chkrt ) )/( 2.*(psi2ij-1.) );

			MEL(B,i,j) = mu2 - mui*muj;  /* while it is around */
			MEL(B,j,i) = MEL(B,i,j);
			    } /* c2 */
			  } /* c1 */
			}
			     
		}
	for ( i = 0 ; i < ni ; i++ ){
	  plugmat=create_matrix( cuts, cuts, EPHEMERAL);
	  for( c1 = 0; c1 < cuts; c1++ ){
	    mui = MEL( mu1, cuts * i + c1, 0);
	    MEL(plugmat,c1,c1) = mui * (1.0 - mui);
	    for( c2 =(c1+1); c2 < cuts; c2++){
	      muj = MEL( mu1, cuts * i + c2, 0);
	      MEL(plugmat,c1,c2) = muj - mui * muj;
	      MEL(plugmat,c2,c1) = muj - mui * muj;
	    }
	  }
	  plug( plugmat, B, i*cuts, i*cuts );
	}
	}
	else
           {
           B = create_matrix( ni * cuts, ni * cuts, PERMANENT );
           for ( i = 0 ; i < ni ; i++ ){
	     plugmat=create_matrix( cuts, cuts, EPHEMERAL);
	     for( c1 = 0; c1 < cuts; c1++ ){
	       mui = MEL( mu1, cuts * i + c1, 0);
	       MEL(plugmat,c1,c1) = mui * (1.0 - mui);
	       for( c2 =(c1+1); c2 < cuts; c2++){
		 muj = MEL( mu1, cuts * i + c2, 0);
		 MEL(plugmat,c1,c2) = muj - mui * muj;
		 MEL(plugmat,c2,c1) = muj - mui * muj;
	       }
	     }
	     plug( plugmat, B, i*cuts, i*cuts );
	   }         
           }



	C = px1_times_pxq( 
		 px1_times_pxq( mu1, oneminus( mu1 ) ) , X[c] );

	make_permanent(C);

	/* op = matmult( transp(C), sweep(B) ); */

	   Binvc = invwcond(B);
	   if (Binvc->condition < mincond) mincond = Binvc->condition;
	   if ( Binvc->condition < .03 && condcount < 6) 
	       {
	       condcount++;
	       fprintf(stderr,
			"get_beta_comps: full weighting has low condition #\n");
	       fprintf(stderr,
			"get_beta_comps: cluster %d, cond(dgeco) = %lf\n", c,
							   Binvc->condition );
	       fprintf(stderr,
			"get_beta_comps: consider independence model for beta\n");
		if ( condcount > 4 ) 
		   fprintf(stderr,"No more condition msgs this iter.\n");
	       }
	   op = matmult( transp(C), Binvc->mat );
	 

	make_permanent(op);

	del1 = matmult( op, C );

	S = matsub( Y[c] , mu1 );

	del2 = matmult( op, S );
	ans->SB[c] = matcopy( del2 );

	make_permanent( del1 );
	make_permanent( del2 );


	destroy_matrix(psi2);
	destroy_matrix(B);
	destroy_matrix(C);


      }else{

	S = matsub( Y[c] , mu1 );
	del2 = matmult( op, S );
	
	make_permanent( del2 );

	ans->SB[c] = matcopy( del2 );


      }/* change */

	
	del1s = matadd( del1s, del1 );

	del2s = matadd( del2s, del2 );

	destroy_matrix(del2);


        kill=0;
        if( c == (nclust-1) ){
	  kill=1;
	}else{
	  kill = (int) MEL(change,c+1,0);
	}

	if( kill ){
	    destroy_matrix(mu1);
	    destroy_matrix(op);
	    destroy_matrix(del1);
	  }

	} /* c loop */

make_permanent( del1s );
make_permanent( del2s );
ans->X1 = del1s;
ans->X2 = del2s;
return ans;
}


MATRIX_TRIPLET_P *get_alpha_ALR( nclust, X, Y, Z, beta,
				 alpha, Flip, cuts, change )
int nclust, Flip, cuts;
MATRIX **X, **Y, **Z, *beta, *alpha, *change;
{
MATRIX_TRIPLET_P *alpha_comps;
int ni, nc2, r0, c, i, j, k, l, p, q, lz, I, J, c1, c2;
double chkrt, a, mui, muj, psi2ij, gamr, tmpm, mu2ij, tmpd, ttt,
   tmpN1, tmpf2d, tmpf2, Zrk, Alphak, dadalk, dNdal,
   Dn, mpr, xil, xjl, dmidbl, dmjdbl, dadbl, dnrdbl, tmpf,
   dDdalk, dndalk, Zij, toff, tmpalogit;
MATRIX *D, *G, *E, *ystar, *mu1, *psi2, *Zeta, *adel1s, *adel2s,
   *aH1, *saH2, *aop, *thisZ, *DtEG, *td, *thisx, *thisy;
MATRIX_TRIPLET_P *ans;
int  kill;


ans = (MATRIX_TRIPLET_P *)calloc( 1, (unsigned)sizeof(struct matrix_triplet_p));
ans->SA = ( MATRIX **)calloc(nclust,(unsigned)sizeof(struct matrix));
if ( ans->SA == (MATRIX **)NULL)
	{
	fprintf(stderr,"MATRIX_TRIPLE_P out of space for SA\n");
	exit(1);
	}

p = X[0]->ncols;
q = Z[0]->ncols;

adel1s = create_matrix( q, q, EPHEMERAL );
adel2s = create_matrix( q, 1, EPHEMERAL );
DtEG = create_matrix( q, p, EPHEMERAL );


for ( c = 0 ; c < nclust ; c++ ){
	
	ni = X[c]->nrows;

	ni = ni/cuts;

	if ( ni == 1 ){

	  ans->SA[c] = create_matrix( q, 1, EPHEMERAL );

	}else{

   if( MEL(change,c,0)!=10.0 ){


	if ( Flip )
		{
		thisx = ord_flip(X[c],cuts);
		thisy = ord_flip(Y[c],cuts);
		}
	else
		{
		thisx = matcopy(X[c]);
		thisy = matcopy(Y[c]);
		}
	make_permanent( thisx );
	make_permanent( thisy );


	nc2 = choose2( ni );

	G = create_matrix( nc2 * cuts * cuts, p, PERMANENT );
	E = create_matrix( nc2 * cuts * cuts, 1, PERMANENT );

	ystar = ord_star(thisy,cuts);
	make_permanent( ystar );

	Zeta = create_matrix( nc2 * cuts * cuts, 1, PERMANENT );

	if (!Flip)
	{
	thisZ = matcopy( Z[c] );
	make_permanent( thisZ );
	}
	else
	{
	thisZ =  ord_flipz(Z[c],cuts);
	make_permanent( thisZ );
	}


	q = thisZ->ncols;

	D = create_matrix( nc2 * cuts * cuts, q, PERMANENT );

	mu1 = matantilogit( matmult( thisx, beta ));
	psi2 = matexp( matmult( thisZ, alpha ));


	make_permanent(mu1);

	make_permanent(psi2);

	for ( I = 0 ; I < (ni-1) ; I++ )
		{
		for ( J = (I+1) ; J < ni ; J++ )
			{

			  for( c1 = 0 ; c1 < cuts ; c1++ ){
			    for( c2 = 0 ; c2 < cuts ; c2++ ){

			      i = cuts * I + c1;
			      j = cuts * J + c2;

			r0 = ord_rfun( ni, cuts, I, J, c1, c2 ); 

			psi2ij = MEL( psi2, r0, 0 );

			gamr = log( psi2ij );

			mui = MEL( mu1, i, 0 );
			muj = MEL( mu1, j, 0 );

			mpr = mui*muj;

			a = 1. + (mui+muj)*(psi2ij-1.);

			chkrt = a*a - 4.*psi2ij*(psi2ij-1.)*mpr;

			if (chkrt < 0.) 
			  fprintf(stderr,"Mu2 calcs have invalid sqrt.\n");

		/*	if (abs(psi2ij-1.) < SMALL )
			  fprintf(stderr,"Mu2 calcs have invalid denom.\n"); */


			tmpm = a - sqrt(chkrt) ;

			if ( fabs(psi2ij-1.) < SMALL ) mu2ij = mpr;

			else mu2ij =
			  ( a - sqrt( chkrt ) )/( 2.*(psi2ij-1.) );

		        tmpd = 1. - ( mui + muj ) + mu2ij ;

			toff = (mui - mu2ij)/ tmpd;

			if ( toff < SMALL )
			  fprintf(stderr,"offset calc log of %f, omitted \n",
						 toff);

			tmpalogit = gamr*MEL(thisy,j,0) + log(toff);


			MEL(Zeta,r0,0) = exp(tmpalogit)/(1.+exp(tmpalogit));

			tmpN1 = 1./sqrt(chkrt);
			tmpf2d = (mui-mu2ij)*tmpd;
			tmpf2 = (muj-1.)/((mui-mu2ij)*tmpd);
			tmpf = (mui - mu2ij)/tmpd;

			Zij = MEL(Zeta,r0,0);

			for ( k = 0 ; k < q ; k++ )
				{
				Zrk = MEL( thisZ, r0, k );
				Alphak = MEL( alpha, k, 0 );
				dadalk = (mui+muj)*Zrk*psi2ij;
				Dn = 2.*(psi2ij-1.);

				dNdal = dadalk - .5*tmpN1*
				   (2.*a*dadalk - 
					4.*mpr*(2.*psi2ij -1.)*Zrk*psi2ij );

				dDdalk = 2.*Zrk*psi2ij;


				if ( fabs(Dn) < 2.*SMALL )
					{
				/*	fprintf(stderr,"Dn small.\n"); */
					dndalk = 0.;
					}
				else dndalk = (dNdal*Dn-dDdalk*tmpm)/(Dn*Dn);

				MEL( D, r0 , k ) = Zij*(1.-Zij)*
					     (Zrk*MEL(thisy,j,0)+
						dndalk*tmpf2);
				}

			/* */
			for ( l = 0 ; l < p ; l++ )
				{
				xil = MEL(thisx,i,l);
				xjl = MEL(thisx,j,l);

				dmidbl = xil*mui*(1.-mui);
				dmjdbl = xjl*muj*(1.-muj);

				dadbl = (psi2ij-1.)*(dmidbl+dmjdbl);
				if( fabs(psi2ij-1.)<SMALL ){
				  dnrdbl = ( dadbl - .5*tmpN1*(2.*a*dadbl-4.*psi2ij*
						     (psi2ij-1.)*
						     (dmidbl*muj+dmjdbl*mui)))/
								(2.*(psi2ij-1.));
				}else{
				  dnrdbl = dmidbl*muj + dmjdbl*mui;
				}
				

				MEL(G,r0,l) = Zij*(1.-Zij)*(1./tmpf)*
						((dmidbl-dnrdbl)*(1.-muj)
						+dmjdbl*(mui-mu2ij))/(tmpd*tmpd);

			      }
			/* */
			MEL(E,r0,0) = 1./(Zij*(1.-Zij));
		          }/* c2 */
			  }/* c1 */
			} /* j */
		} /* i */


	aop = matxdiagasvec( transp(D), E );

	make_permanent( aop );

	aH1 = matmult( aop , D );
	make_permanent( aH1 );

	saH2 = matmult( aop, matsub( ystar, Zeta ) );
	ans->SA[c] = matcopy(saH2);

	td = matmult( aop, G ); 
	make_permanent( td );


	destroy_matrix(D);
	destroy_matrix(G);
	destroy_matrix(E);
	destroy_matrix(mu1);
	destroy_matrix(thisx);
	destroy_matrix(thisy);
	destroy_matrix(thisZ);
	destroy_matrix(psi2);
	destroy_matrix(ystar);
/*        destroy_matrix(Zeta); */
/*        destroy_matrix(aop);  */
	

      }else{               /* no XZchange */

	if( Flip ){
	  thisy = ord_flip( Y[c], cuts );
	}else{
	  thisy = matcopy( Y[c] );
	}
	ystar = ord_star( thisy, cuts );
	saH2 = matmult( aop, matsub( ystar, Zeta ) );

	ans->SA[c] = matcopy( saH2 );

      }/* end else for XZchange */


	adel1s = matadd( adel1s, aH1 );
	adel2s = matadd( adel2s, saH2 );
	DtEG = matadd( DtEG, td );

        kill=0;
        if( c==(nclust-1) ){
	  kill=1;
	}else{
	  if( (int)MEL(change,c+1,0) ) kill=1;
	}
        if( kill ){
	  destroy_matrix( td );
	  destroy_matrix( aH1 );
	  destroy_matrix( Zeta );
	  destroy_matrix( aop );
	}

      }/* else (ni != 1) */
	
      }/* c loop */

make_permanent( adel1s );
make_permanent( adel2s );
make_permanent( DtEG );
ans->X1 = adel1s;
ans->X2 = adel2s;
ans->X3 = DtEG;
return ans;
}

MATRIX *ord_flip( x, cuts ) 
     MATRIX *x;  
     int    cuts;
{
int i, j, k, c;
MATRIX *o;
o = create_matrix( x->nrows, x->ncols , EPHEMERAL );
j = 0;
for ( i = (x->nrows)/cuts - 1 ; i > -1 ; i-- )
	{
	  for( c=0; c<cuts; c++){
	    for ( k = 0 ; k < x->ncols ; k++ )
	      {
		MEL( o, j, k ) = MEL( x, i+c, k );
	      }
	    j++;
	  } /* c */
	}
free_if_ephemeral(x);
return o;
}

MATRIX *ord_flipz( z, cuts ) 
     MATRIX *z;
     int    cuts;
{
int n, nr, nc, i, j, zoutrow, zinrow, k, c1, c2;
MATRIX *zf;
nr = z->nrows;
nc = z->ncols;

zf = create_matrix( nr, nc, EPHEMERAL );
n = (int)(.5*(double)(1+sqrt((double)(1+8*(nr/(cuts*cuts))))));
zoutrow = 0;
for ( i = n-1 ; i>0 ; i-- )
	{
	for ( j = (i-1); j > -1 ; j-- )
		{
		  for( c1=0; c1<cuts; c1++ ){
		    for( c2=0; c2<cuts; c2++){
		      zinrow = ord_rfun(n,cuts,j,i,c1,c2);
		      for ( k = 0 ; k < nc ; k++ )
			{
			  MEL(zf, zoutrow, k) = MEL( z, zinrow, k );
			}
		      zoutrow++;
		    } /* c2 */
		  } /* c1 */
		}
	}
free_if_ephemeral(z);
return zf;
}

MATRIX *make_rvar( nclust, bc, ac )
int nclust;
MATRIX_PAIR_P *bc;
MATRIX_TRIPLET_P *ac;
{
MATRIX *H1, *H2, *H2A, *H2B, *H2O, *H1I, *ans;
int i, p, q;
FILE  *wfile;

p = (bc->X1)->ncols;
q = (ac->X1)->ncols;

H2A = create_matrix( p, p, PERMANENT );
H2B = create_matrix( q, q, PERMANENT );
H2O = create_matrix( p, q, PERMANENT );

for ( i = 0 ; i < nclust ; i++ )
	{
	make_permanent( bc->SB[i] );
	make_permanent( ac->SA[i] );
	H2A = matadd( H2A, matmult( bc->SB[i], transp( bc->SB[i] ) ) );
	H2B = matadd( H2B, matmult( ac->SA[i], transp( ac->SA[i] ) ) );
	H2O = matadd( H2O, matmult( bc->SB[i], transp( ac->SA[i] ) ) );
	destroy_matrix( bc->SB[i] );
	destroy_matrix( ac->SA[i] );
	}
make_permanent( H2A );
make_permanent( H2B );
make_permanent( H2O );

H1 = create_matrix( p+q, p+q, PERMANENT );
H2 = create_matrix( p+q, p+q, PERMANENT );

plug( bc->X1, H1, 0, 0 );
plug( ac->X3, H1, p, 0 );
plug( ac->X1, H1, p, p ); 

plug( H2A, H2, 0, 0 );
plug( H2O, H2, 0, p );
plug( transp(H2O), H2, p, 0 );
plug( H2B, H2, p, p );

H1I = luinv( H1 );
make_permanent( H1I );

ans = matmult( matmult ( H1I , H2 ), transp(H1I) );

/* dump info for lambda opt calcs... */
wfile=fopen("lambda.mat1","w");
fmatdump( wfile, H1I );
fclose( wfile );
wfile=fopen("lambda.mat2","w");
fmatdump( wfile, H2 );
fclose( wfile );

     Matdump( H1I );
     Matdump( H2 );

destroy_matrix( H1I );
destroy_matrix( H2A );
destroy_matrix( H2B );
destroy_matrix( H2O );
destroy_matrix( H2 );
return ans;
}

int comp_mat(), swap_mat();

MATRIX *matsort(mat)
MATRIX *mat;
{
MATRIX *qSmat;
double *qhead;
int nelem, width;

width = 8;

qSmat = matcopy(mat);
nelem = qSmat->nrows * qSmat->ncols;

qhead = qSmat->data;

qsort( (char *) qhead, nelem, width, comp_mat );
return qSmat;
}

int comp_mat(i,j)
double *i, *j;
{
if (*i<*j) return -1;
if (*i>*j) return 1;
return 0;
}



MATRIX *make_irvar( nclust, bc, ac, fac )
int nclust;
MATRIX_PAIR_P *bc;
MATRIX_TRIPLET_P *ac, *fac;
{
MATRIX *H1, *H2, *H2A, *H2B, *H2O, *ans, *H1I;
MATRIX *fH2B, *fH2O;
int i, p, q;

p = (bc->X1)->ncols;
q = (ac->X1)->ncols;

H2A = create_matrix( p, p, EPHEMERAL );
H2B = create_matrix( q, q, EPHEMERAL);
H2O = create_matrix( p, q, EPHEMERAL );
fH2B = create_matrix( q, q, EPHEMERAL );
fH2O = create_matrix( p, q, EPHEMERAL );

for ( i = 0 ; i < nclust ; i++ )
	{
	make_permanent( bc->SB[i] );
	make_permanent( ac->SA[i] );
	make_permanent( fac->SA[i] );
	H2A = matadd( H2A, matmult( bc->SB[i], transp( bc->SB[i] ) ) );
	H2B = matadd( H2B, matmult( ac->SA[i], transp( ac->SA[i] ) ) );
	H2O = matadd( H2O, matmult( bc->SB[i], transp( ac->SA[i] ) ) );
	fH2B = matadd( fH2B, matmult( fac->SA[i], transp( fac->SA[i] ) ) );
/* next line is new... 94/11/08 */
	fH2O = matadd( fH2O, matmult( bc->SB[i], transp( fac->SA[i] ) ) ); 
	destroy_matrix( bc->SB[i] );
	destroy_matrix( ac->SA[i] );
	destroy_matrix( fac->SA[i] );
	}

H2B = scalar_times_matrix( .5,  matadd( H2B, fH2B ) );
H2O = scalar_times_matrix( .5,  matadd( H2O, fH2O ) );
make_permanent( H2A );
make_permanent( H2B );
make_permanent( H2O );

H1 = create_matrix( p+q, p+q, PERMANENT );
H2 = create_matrix( p+q, p+q, PERMANENT );

Matdump( ac->X3 );
Matdump( fac->X3 );
Matdump( ac->X1 );
Matdump( fac->X1 );

plug( bc->X1, H1, 0, 0 );
plug( scalar_times_matrix( .5,  matadd( ac->X3, fac->X3) ), H1, p, 0 );
plug( scalar_times_matrix( .5, matadd( ac->X1, fac->X1) ), H1, p, p );


H1I = luinv(H1);
make_permanent( H1I );
destroy_matrix( H1 );

Matdump( H1I );

plug( H2A, H2, 0, 0 );
plug( H2O, H2, 0, p );
plug( transp(H2O), H2, p, 0 );
plug( H2B, H2, p, p );

Matdump( H2 );

ans = matmult( matmult ( H1I , H2 ), transp(H1I) );

destroy_matrix( H1I );
destroy_matrix( H2A );
destroy_matrix( H2B );
destroy_matrix( H2O );
/* destroy_matrix( fH2B );
destroy_matrix( fH2O ); */
destroy_matrix( H2 );

return ans;
}

MATRIX *ord_star( x, cuts ) 
     MATRIX *x;
     int    cuts;
{
MATRIX *tmp;
int xr, xc, nc2, i, I, J, c1, c2, curr;
xc = x->ncols;
if ( xc > 1 ) fprintf(stderr,"M+-: star: should have colvec.\n");
xr = x->nrows;
xr = xr/cuts;
nc2 = choose2(xr);

tmp = create_matrix( nc2 * cuts * cuts, 1, EPHEMERAL );

curr = 0;
for ( I = 0 ; I < (xr-1) ; I++ )
  {
        for ( J = (I+1); J < xr ; J++ )
	  {
	    for( c1=0; c1 < cuts; c1++){
	        i = I * cuts;
		for( c2=0; c2<cuts; c2++){
		  MEL( tmp, curr, 0 ) = MEL( x, i+c1, 0 );
		  curr++;
		 } /* c2 */
	        } /* c1 */
	      }
      }
free_if_ephemeral( x );
return tmp;
}


MATRIX_TRIPLET_P *get_alpha_EE1( nclust, X, Y, Z, beta, alpha, cuts,
				 invariant, alpha_block, change )
int    nclust, cuts, invariant, alpha_block;
MATRIX **X, **Y, **Z, *beta, *alpha, *change;
{
MATRIX_TRIPLET_P *alpha_comps;
int ni, nc2, r0, c, i, j, k, l, p, q, lz, I, J, c1, c2, aaa;
double chkrt, a, mui, muj, psi2ij, gamr, tmpm, mu2ij, tmpd, ttt,
   tmpN1, tmpf2d, tmpf2, Zrk, Alphak, dadalk, dNdal,
   Dn, mpr, xil, xjl, dmidbl, dmjdbl, dadbl, dnrdbl, tmpf,
   dDdalk, dndalk, Zij;
MATRIX *D, *G, *E, *ystar, *mu1, *psi2, *Zeta, *adel1s, *adel2s,
   *aH1, *saH2, *aop, *DtEG, *td, **Block, *Wght, *mu2, *temp;
MATRIX_TRIPLET_P *ans;
int  kill;
FILE *wfile;

ans = (MATRIX_TRIPLET_P *)calloc( 1, (unsigned)sizeof(struct matrix_triplet_p));
ans->SA = ( MATRIX **)calloc(nclust,(unsigned)sizeof(struct matrix));
if ( ans->SA == (MATRIX **)NULL)
	{
	fprintf(stderr,"MATRIX_TRIPLE_P out of space for SA\n");
	exit(1);
	}

p = X[0]->ncols;
q = Z[0]->ncols;

adel1s = create_matrix( q, q, EPHEMERAL );
adel2s = create_matrix( q, 1, EPHEMERAL );
DtEG = create_matrix( q, p, EPHEMERAL );

for ( c = 0 ; c < nclust ; c++ ){

	ni = X[c]->nrows;

	ni = ni/cuts;

	if ( ni == 1 ){
	  
	  ans->SA[c] = create_matrix( q, 1, EPHEMERAL );

	}else{                  /* singles switch */


  if( (int)MEL(change,c,0) ){

	nc2 = choose2( ni );

	G = create_matrix( nc2 * cuts * cuts, p, PERMANENT );
	E = create_matrix( nc2 * cuts * cuts, 1, PERMANENT );


	Zeta = create_matrix( nc2 * cuts * cuts, 1, PERMANENT );

	q = Z[c]->ncols;

	D = create_matrix( nc2 * cuts * cuts, q, PERMANENT );

	mu1 = matantilogit( matmult( X[c], beta ));
	make_permanent(mu1);

	psi2 = matexp( matmult( Z[c], alpha ));
	make_permanent(psi2);

	if( alpha_block ){
	  mu2 = create_matrix( psi2->nrows, 1, PERMANENT );
	}

	if( invariant ){
	  ystar = ord_star_EE1(matsub(Y[c],mu1),cuts);
	}else{
	  ystar = ord_star_EE1(Y[c],cuts);
	}
	make_permanent( ystar );

	for ( I = 0 ; I < (ni-1) ; I++ )
		{
		for ( J = (I+1) ; J < ni ; J++ )
			{

			  for( c1 = 0 ; c1 < cuts ; c1++ ){
			    for( c2 = 0 ; c2 < cuts ; c2++ ){

			      i = cuts * I + c1;
			      j = cuts * J + c2;

			r0 = ord_rfun( ni, cuts, I, J, c1, c2 ); 

			psi2ij = MEL( psi2, r0, 0 );

			mui = MEL( mu1, i, 0 );
			muj = MEL( mu1, j, 0 );

			mpr = mui*muj;

			a = 1. + (mui+muj)*(psi2ij-1.);

			chkrt = a*a - 4.*psi2ij*(psi2ij-1.)*mpr;

			if (chkrt < 0.) 
			  fprintf(stderr,"Mu2 calcs have invalid sqrt.\n");


			tmpm = a - sqrt(chkrt) ;

			if ( fabs(psi2ij-1.) < SMALL ){
			  mu2ij = mpr;
			}else{ 
			  mu2ij = ( a - sqrt( chkrt ) )/( 2.*(psi2ij-1.) );
			}

			MEL(Zeta,r0,0) = mu2ij;
			if( invariant ) MEL(Zeta,r0,0) = mu2ij - mui*muj;
			if( alpha_block ) MEL(mu2,r0,0) = mu2ij;

		      if( fabs(psi2ij-1.) >= SMALL ){
		        tmpd = 1. - ( mui + muj ) + mu2ij ;
			tmpN1 = 1./sqrt(chkrt);
			tmpf2d = (mui-mu2ij)*tmpd;
			tmpf2 = (muj-1.)/((mui-mu2ij)*tmpd);
			tmpf = (mui - mu2ij)/tmpd;
		      }

			Zij = MEL(Zeta,r0,0);

			for ( k = 0 ; k < q ; k++ )
				{
				Zrk = MEL( Z[c], r0, k );
				Alphak = MEL( alpha, k, 0 );
				dadalk = (mui+muj)*Zrk*psi2ij;
				Dn = 2.*(psi2ij-1.);


				if ( fabs(Dn) < 2.*SMALL )
					{
				      /* fprintf(stderr,"Dn small.\n"); */
					dndalk = 0.;
					}
				else 
				  {
				    dNdal = dadalk - .5*tmpN1*
				      (2.*a*dadalk - 
				       4.*mpr*(2.*psi2ij -1.)*Zrk*psi2ij );

				    dDdalk = 2.*Zrk*psi2ij;

				    dndalk = (dNdal*Dn-dDdalk*tmpm)/(Dn*Dn);
				  }

				MEL( D, r0 , k ) = dndalk;

				}

			/* */
			for ( l = 0 ; l < p ; l++ )
				{
				xil = MEL(X[c],i,l);
				xjl = MEL(X[c],j,l);

				dmidbl = xil*mui*(1.-mui);
				dmjdbl = xjl*muj*(1.-muj);
				
				if( fabs(psi2ij-1.) >= SMALL ){

				dadbl = (psi2ij-1.)*(dmidbl+dmjdbl);
				dnrdbl = ( dadbl - .5*tmpN1*(2.*a*dadbl-4.*psi2ij*
						     (psi2ij-1.)*
						     (dmidbl*muj+dmjdbl*mui)))/
								(2.*(psi2ij-1.)); 

/*				dadbl = (dmidbl+dmjdbl);
				dnrdbl = ( dadbl - .5*tmpN1*(2.*a*dadbl-4.*
					    psi2ij*(dmidbl*muj+dmjdbl*mui)))/2.;  */
			      }else{  /* */

				dnrdbl = dmidbl*muj + dmjdbl*mui;

			      }
				
				MEL(G,r0,l) = dnrdbl;

				if( invariant ) MEL(G,r0,l) = dnrdbl -
				                              mui*dmjdbl -
							      muj*dmidbl;

				}

			      if( invariant ){
				ttt = mu2ij * (1.-mu2ij) +
				      mu2ij*( 6.*mui*muj - 2.*(mui+muj) ) +
				      mui*muj*( mui+muj - 4.*mui*muj );

				MEL(E,r0,0) = 1./ttt;
			      }else{
				MEL(E,r0,0) = 1./(Zij*(1.-Zij)); 
			      }
		          }/* c2 */
			  }/* c1 */
			} /* j */
		} /* i */

	if( alpha_block ){
	  Block = get_alpha_blocks( mu1, mu2, ni, cuts, invariant );

	  /* NOTE:  Block[k] is symmetric so no need to transp() */
	  aop = transp( blockdiag_x_mat( Block, D, nc2 ) );

	  destroy_matrix( mu2 );
	  cfree( Block );
	}else{  /* -- */
	  aop = matxdiagasvec( transp(D), E );
	}

	make_permanent( aop );

	aH1 = matmult( aop , D );
	make_permanent( aH1 );

	saH2 = matmult( aop, matsub( ystar, Zeta ) );
	ans->SA[c] = matcopy(saH2);

	td = matmult( aop, G ); 
	make_permanent( td );


	destroy_matrix(D);
	destroy_matrix(G);
	destroy_matrix(E);
	destroy_matrix(psi2);
	destroy_matrix(ystar);
/*	destroy_matrix(mu1); */
/*	destroy_matrix(Zeta); */
/*      destroy_matrix(aop); */



      }else{           /* no XZchange */

	if( invariant ){
	  ystar = ord_star_EE1( matsub( Y[c], mu1 ), cuts );
	}else{
	  ystar = ord_star_EE1( Y[c] , cuts );
	}

	saH2 = matmult( aop, matsub( ystar, Zeta ) );
	ans->SA[c] = matcopy(saH2);

      }/* end XZchange switch */


	adel1s = matadd( adel1s, aH1 );
	adel2s = matadd( adel2s, saH2 );
	DtEG = matadd( DtEG, td );

        kill=0;
        if( c==(nclust-1) ){
	  kill=1;
	}else{
	  if( MEL(change,c+1,0)==1.0 ) kill=1;
	}

        if( kill ){
	  destroy_matrix( td );
	  destroy_matrix( aH1 );
	  destroy_matrix( Zeta );
	  destroy_matrix( mu1 );
	  destroy_matrix( aop );
	}

      }/* end else (ni != 1) */
	   
      }/* c loop */


make_permanent( adel1s );
make_permanent( adel2s );
make_permanent( DtEG );
ans->X1 = adel1s;
ans->X2 = adel2s;
ans->X3 = DtEG;
return ans;
}


MATRIX *ord_star_EE1( x, cuts ) 
     MATRIX *x;
     int    cuts;
{
MATRIX *tmp;
int xr, xc, nc2, i, j, I, J, c1, c2, curr;
xc = x->ncols;
if ( xc > 1 ) fprintf(stderr,"M+-: star: should have colvec.\n");
xr = x->nrows;
xr = xr/cuts;
nc2 = choose2(xr);

tmp = create_matrix( nc2 * cuts * cuts, 1, EPHEMERAL );

curr = 0;
for ( I = 0 ; I < (xr-1) ; I++ )
  {
        for ( J = (I+1); J < xr ; J++ )
	  {
	    for( c1=0; c1 < cuts; c1++){
	        i = I * cuts;
		j = J * cuts;
		for( c2=0; c2<cuts; c2++){
		  MEL( tmp, curr, 0 ) = MEL( x, i+c1, 0 ) * MEL( x, j+c2, 0);
		  curr++;
		 } /* c2 */
	        } /* c1 */
	      }
      }
free_if_ephemeral( x );
return tmp;
}
/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */

MATRIX  *blockdiag_x_mat( block, mat, nblocks )

  MATRIX **block, *mat;
  int    nblocks;
{
  int     i, change, row, row_start, row_stop;
  MATRIX  *ans, *temp1, *temp2, *plugmat;

row=0;
for(i=0;i<nblocks;i++){
  row += block[i]->nrows;
}

ans = create_matrix( row, mat->ncols, EPHEMERAL );

change=0;
if( is_ephemeral(mat) ){
  change=1;
  make_permanent( mat );
}

row_start=0;
row_stop=0;

for(i=0;i<nblocks;i++){
  row_stop = row_start -1 + block[i]->ncols;
  temp1 = extract_rows( mat, row_start, row_stop );
  temp2 = matmult( block[i], temp1 );
  plug( temp2, ans, row_start, 0 );
  row_start = row_stop + 1;
}

if( change ){
  destroy_matrix( mat );
}
 
return ans;
}
/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */


MATWCOND *invwcond( x )

MATRIX *x;
{
MATWCOND *out;
MATRIX *tx;
double *head, *z, cond, *det, *work;
int nr, *ipvt, job, nargs;

cond = 0.;
out = (MATWCOND *)calloc( 1, (unsigned)sizeof(struct matwcond) );
out->mat = (MATRIX *) calloc( 1, (unsigned)sizeof(struct matrix) );

tx = transp(x); /* this cleans x if ephemeral */
nr = tx->nrows;
ipvt = (int *)calloc( nr, (unsigned)sizeof(int) );
z = (double *)calloc( nr, (unsigned)sizeof(double) );
head = tx->data;

nargs = 6;
dgecoXXY_( head, &nr, &nr, ipvt, &cond, z, &nargs);

det = (double *)calloc( 2, (unsigned)sizeof(double) );
work = (double *)calloc( nr, (unsigned)sizeof(double) );

job = 1;
nargs = 7;

dgediXXY_( head, &nr, &nr, ipvt, det, work, &job, &nargs );

out->condition = cond;
tx = transp(tx);  /* kills */
out->mat = tx;

cfree( ipvt );
cfree( z );
cfree( det );
cfree( work );

return out;
}
/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */

int ord_rfun( n, cuts, i, j, c1, c2 ) 
     int n,i,j,c1,c2,cuts;
{
  int r0, ans;
	  
  i = i+1;  /* use zero basis as input */
  j = j+1;
  c1 = c1+1;
  c2 = c2+1;
  
  r0 = ((i-1)*n - i*(i-1)/2 + j-i); 
  ans = (r0-1)*cuts*cuts + (c1-1)*cuts + c2;
  ans = ans-1; /* return zero basis */

  return ans;
}
/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */

MATRIX **get_alpha_blocks( mu1, mu2, n, cuts, invariant )

  MATRIX *mu1, *mu2;
  int    n, cuts, invariant;
{
  MATRIX **Block, *m1i, *m1j, *m2, *zeta;
  int    i, j, r0, c0, nc2, a, b, c, d, row, col, count;
  int    maxac, maxbd;
  double ttt;

  nc2 = n*(n-1)/2;
  set_matrix_array( Block, nc2 );

gPrint("[1]\n");
gPrint("mu1\n");
gMatdump(mu1);
gPrint("mu2\n");
gMatdump(mu2);

  count=0;
  for(i=0;i<(n-1);i++){
    for(j=(i+1);j<n;j++){

      Block[count]=create_matrix( cuts*cuts, cuts*cuts, EPHEMERAL );

      m1i = create_matrix( cuts, 1, EPHEMERAL );
      for(a=0;a<cuts;a++) MEL( m1i, a, 0 ) = MEL( mu1, i*cuts + a, 0 );
gPrint("mu1i\n");
gMatdump(m1i);
      m1j = create_matrix( cuts, 1, EPHEMERAL );
      for(a=0;a<cuts;a++) MEL( m1j, a, 0 ) = MEL( mu1, j*cuts + a, 0 );
gPrint("mu1j\n");
gMatdump(m1j);
      r0 = ord_rfun( n, cuts, i, j, 0, 0 );
      m2 = create_matrix( cuts*cuts, 1, EPHEMERAL );
      for(a=0;a<cuts*cuts;a++) MEL( m2, a, 0 ) = MEL( mu2, r0+a, 0 );
gPrint("m2\n");
gMatdump(m2);
      if( invariant ){
	zeta = create_matrix( cuts*cuts, 1, EPHEMERAL );
	for(a=0;a<cuts;a++){
	  for(b=0;b<cuts;b++){ 
	    MEL(zeta, a*cuts + b, 0 ) = MEL(m2, a*cuts + b, 0) -
	                                 MEL(m1i,a,0) * MEL(m1j,b,0);
	  }
	}
gPrint("zeta\n");
gMatdump(zeta);
      }


gPrint("[2]\n");

      row=0;
      for(a=0;a<cuts;a++){
	for(b=0;b<cuts;b++){
	  col=0;
	  for(c=0;c<cuts;c++){
	    for(d=0;d<cuts;d++){
	      if( row >= col ){ 
		maxac = IMAX(a,c);
		maxbd = IMAX(b,d);
		ttt = MEL( m2, maxac*cuts + maxbd, 0 );
		if( invariant ){
		  ttt = ttt
		   - MEL( m2, maxac*cuts + b, 0 ) * MEL( m1j, d, 0 )
		   - MEL( m2, maxac*cuts + d, 0 ) * MEL( m1j, b, 0 )
		   - MEL( m2, a*cuts + maxbd, 0 ) * MEL( m1i, c, 0 )
		   - MEL( m2, c*cuts + maxbd, 0 ) * MEL( m1i, a, 0 )
		   + MEL( m2, a*cuts + b, 0 ) * MEL( m1i,c,0 ) * MEL( m1j,d,0 )
		   + MEL( m1i, maxac, 0 ) * MEL( m1j,b,0 ) * MEL( m1j,d,0 )
		   + MEL( m2, c*cuts + b, 0 ) * MEL( m1i,a,0 ) * MEL( m1j,d,0 )
		   + MEL( m2, a*cuts + d, 0 ) * MEL( m1i,c,0 ) * MEL( m1j,b,0 )
		   + MEL( m1j, maxbd, 0 ) * MEL( m1i,a,0 ) * MEL( m1i,c,0 )
		   + MEL( m2, c*cuts + d, 0 ) * MEL( m1i,a,0 ) * MEL( m1j,b,0 )
		   - 3.0 * MEL(m1i,a,0) * MEL(m1j,b,0) 
		         * MEL(m1i,c,0) * MEL(m1j,d,0); }/* invariant */
		MEL( Block[count], row, col ) = ttt;
		MEL( Block[count], col, row ) = ttt; }/* row >= col */
	      col++;
	    }/* d */
	  }/* c */
	  row++;
	}/* b */
      }/* a */

gPrint("[3]\n");

      if( invariant ){
	make_permanent( zeta );
	Block[count] = matsub( Block[count], matmult( zeta, transp(zeta) ) );
	destroy_matrix( zeta );
      }else{
	make_permanent( m2 );
	Block[count] = matsub( Block[count], matmult( m2, transp(m2) ) );
      }

/* get the inverse... */

      Block[count] = luinv( Block[count] );

      destroy_matrix( m2 );
      destroy_matrix( m1i );
      destroy_matrix( m1j );
      count++;
    }/* j */
  }/* i */

  free_if_ephemeral( mu1 );
  free_if_ephemeral( mu2 );

  return Block;

}
/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */



