# Function creates an odds ratio matrix from the argument
#     data matrix
# Assume have loaded functions i.mat(), j.mat(), and or.mat()
#
or.mat_function(x,zero.cell=0){
       n.vars _ dim(x)[2]
     # make matrix of non-missing totals
       z_!is.na(x)
       mode(z)_"numeric"
       n.obs  _t(z)%*%z
     # replace missing values with zeros
       x[is.na(x)]_0
     # calculate odd ratio matrix
       d_t(x)%*%x
       tot.col_t(z) %*% x
       tot.row_t(x) %*% z
       denom_(tot.row-d+zero.cell)*(tot.col-d+zero.cell)
       numer_(n.obs-tot.col-tot.row+d+zero.cell)*(d+zero.cell)
       or_numer/denom
       return(or)
                  }

lor.mat_function(x,zero.cell=.5){
       n.vars _ dim(x)[2]
     # make matrix of non-missing totals
       z_!is.na(x)
       mode(z)_"numeric"
       n.obs  _t(z)%*%z
     # replace missing values with zeros
       x[is.na(x)]_0
     # calculate odd ratio matrix
       d_t(x)%*%x
       tot.col_t(z) %*% x
       tot.row_t(x) %*% z
       denom_(tot.row-d+zero.cell)*(tot.col-d+zero.cell)
       numer_(n.obs-tot.col-tot.row+d+zero.cell)*(d+zero.cell) 
       lor_log(numer/denom)  
       lor_lor+diag(rep(Inf,n.vars))    
       return(lor)
                  }

lor.va.mat_function(x,zero.cell=.5){
       n.vars _ dim(x)[2]
     # make matrix of non-missing totals
       z_!is.na(x)
       mode(z)_"numeric"
       n.obs  _t(z)%*%z
     # replace missing values with zeros
       x[is.na(x)]_0
     # calculate odd ratio matrix
       d_t(x)%*%x
       tot.col_t(z) %*% x
       tot.row_t(x) %*% z
       lor.va_1/(tot.row-d+zero.cell) + 1/(tot.col-d+zero.cell) + 
              1/(n.obs-tot.col-tot.row+d+zero.cell) + 1/(d+zero.cell) 
       lor.va_lor.va+diag(rep(Inf,n.vars))    
       return(lor.va)
                  }
