z.class_function(gvec,id,inter.only=T)
{
#
# PURPOSE:	create kernel Z-matrix for ord.EE().
#
# INPUT:  	id = cluster identifier
#		gvec = class identifier -- integer-valued from
#                      1 to number of classes.
#		inter.only = logical value indicating that all 
#			associations are between classes (e.g. if 
#			modelling association among items)
# RETURN:	returns list with Z structures needed by ord.EE.setup()
#
	if(!is.loaded(symbol.C("class2z"))) {
		print("This function calls class2z.")
		print("the object file 'C2Z.o' is not loaded.")
		print("please load this file and try again.")
		stop(0)
	}
	if(is.factor(gvec)){gvec_unclass(gvec)}
	if(min(gvec) != 1) {
		print(paste("gvec min is", min(gvec), "."))
		print("expect gvec to range from 1 to max # classes!")
		stop(0)
	}
	k <- max(gvec)
	# Build matrix
	if(inter.only) {
		b.model_cbind(0,rbind(0,i.mat(k*(k+1)/2-1)))
		b.model[2:nrow(b.model),2]_1
		} else {
		b.model_cbind(1,rbind(0,i.mat(k*(k+1)/2-1)))
		}
	out1 <- class2z(id = id, cvec = gvec, k = k, dmat = b.model)
	dimnames(out1$z)_list(NULL,dimnames(out1$model)[[1]])
	out1$z_out1$z[,(apply(out1$z,2,sum)>0)]
	# Fix up names
	nms_dimnames(out1$z)[[2]]
	nms_paste(nms,c("",paste("v",rep(nms[1],length(nms)-1),sep="")),sep="")
	dimnames(out1$z)_list(NULL,nms)
	return(zid=out1$zid,z=out1$z)
}
