/*---------------------------------------------------------------------------*/
/* z_dsp.c                                                                   */
/*---------------------------------------------------------------------------*/

#include "z_dsp.h"


void z_dsp( x, id, z, zid, n, nrz, nclust, flag )

     double *x, *id, *z, *zid;
     int    *n, *nrz, *nclust, *flag;

{
  MATRIX *X[MAX_NUM_CLUSTS], *ID[MAX_NUM_CLUSTS], *xin, *idin;
  MATRIX *Z, *Zid, *ID_num;
  int    i, j, one, count, ni, cc, rr, q;
  double xi, xj;

  one=1;
  q=3;

  from_S( x, n, &one, xin);
  from_S( id, n, &one, idin);
  from_S( z, nrz, &q, Z);
  from_S( zid, nrz, &one, Zid);


  if( *nclust > MAX_NUM_CLUSTS ){ printf("nclust = %i, MAX_NUM_CLUSTS = %i.\n",
					 *nclust,MAX_NUM_CLUSTS);
				  printf("change z_dsp.h and recompile.\n");
				  exit(1); }

printf("[1]\n");

  split(xin,idin,X);
  split(idin,idin,ID);
  destroy_matrix(idin);
  destroy_matrix(xin);

  ID_num=create_matrix(*nclust,one,EPHEMERAL);
  for(i=0;i<*nclust;i++){
    MEL(ID_num,i,0)=MEL(ID[i],0,0);
    destroy_matrix(ID[i]);
  }

printf("[2]\n");

  count=0;
  for(cc=0;cc<*nclust;cc++){
    ni=X[cc]->nrows;
    if(ni==1){
      for(rr=0;rr<q;rr++) MEL(Z,count,rr)=0.0;
      MEL(Zid,count,0)=MEL(ID_num,cc,0);
      count++; 
    }else{
      for(i=0;i<(ni-1);i++){
	for(j=(i+1);j<ni;j++){
	  xi = MEL( X[cc],i,0 );
	  xj = MEL( X[cc],j,0 );
	  MEL(Z,count,0)= xi - xj;
	  MEL(Z,count,1)= xi + xj;
	  MEL(Z,count,2)= xi * xj;
	  MEL(Zid,count,0)=MEL(ID_num,cc,0);
	  count++;
	}
      }
    }

  }

printf("[3]\n");

  if( count != Z->nrows ) *flag=1;

    to_S( Z, z);
    to_S( Zid, zid);

    for(i=0;i<*nclust;i++) destroy_matrix(X[i]);
    destroy_matrix(ID_num);


}
/*---------------------------------------------------------------------------*/


