z.dsp<-function( x, id ){
#
# S function to take covariate (x) and cluster indicator (id), and 
# create functions for use in building the association design matrix, Z.  
# The output contains the following:
#           
#                  zid = cluster identifier for association regression
#                delta = xi - xj
#                sigma = xi + xj
#                   pi = xi * xj
#                 flag = error indicator
#

        len_length
	if( len(x) != len(id) ){
		print("x and id are unequal length.")
		stop("exit z.dsp()") }
#
	tt_table(id)
	nclust_len(tt)
	n_len(x)

	total_0
	tt_table(table(id))
	y_as.integer(names(tt))
	for(i in 1:len(tt)){
		if( y[i]>1 ){
			total_total + tt[i]*(y[i]*(y[i]-1)/2)
		}else{
			total_total + tt[i]
		}
	}

	z_matrix(0,total,ncol=3)
	zid_matrix(0,total,1)
	flag_0

	c.out<-.C("z_dsp",
		x=as.double(x),
		id=as.double(id),
		z=z,
		zid=as.double(zid),
		n=as.integer(n),
		nrz=as.integer(total),
		nclust=as.integer(nclust),
		flag=as.integer(flag)) 

	out_list(zid=c.out$zid,delta=c.out$z[,1],sigma=c.out$z[,2],
		 pi=c.out$z[,3],flag=c.out$flag)
	out
}
